package net.sourceforge.openutils.notifications.notifiers;

import java.util.List;
import java.util.Map;

import net.sourceforge.openutils.notifications.Notification;
import net.sourceforge.openutils.notifications.NotificationException;
import net.sourceforge.openutils.notifications.messages.FreemarkerEmailNotification;
import freemarker.template.Configuration;


/**
 * @author molaschi
 * @version $Id: $
 */
public class FreemarkerEmailNotifier extends EmailNotifier
{

    Configuration configuration;

    Map<String, Object> data;

    /**
     * Sets the data.
     * @param data the data to set
     */
    public void setData(Map<String, Object> data)
    {
        this.data = data;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean send(String from, List<String> toAddresses, List<String> ccAddresses, List<String> ccnAddresses,
        Notification notification) throws NotificationException
    {
        if (notification instanceof FreemarkerEmailNotification)
        {
            ((FreemarkerEmailNotification) notification).setConfiguration(configuration);
            ((FreemarkerEmailNotification) notification).setData(data);
        }
        return super.send(from, toAddresses, ccAddresses, ccnAddresses, notification);
    }

    /**
     * Sets the configuration.
     * @param configuration the configuration to set
     */
    public void setConfiguration(Configuration configuration)
    {
        this.configuration = configuration;
    }

}