package net.sourceforge.openutils.notifications.services;

import java.util.List;

import net.sourceforge.openutils.notifications.Notification;
import net.sourceforge.openutils.notifications.NotificationException;


/**
 * @author molaschi
 * @version $Id: $
 */
public interface NotificationManager
{

    /**
     * Send notification
     * @param from sender
     * @param toAddresses list of receivers
     * @param ccAddresses list of cc
     * @param notification notification
     * @param <T> Class that extends Notification interface
     * @return true if mail is sent
     */
    boolean send(String from, List<String> toAddresses, List<String> ccAddresses, Notification notification)
        throws NotificationException;

    /**
     * Send notification
     * @param from sender
     * @param toAddresses list of receivers
     * @param ccAddresses list of cc
     * @param ccnAddresses list of ccn
     * @param notification notification
     * @param <T> Class that extends Notification interface
     * @return true if mail is sent
     */
    boolean send(String from, List<String> toAddresses, List<String> ccAddresses, List<String> ccnAddresses,
        Notification notification) throws NotificationException;

    /**
     * Send notification
     * @param from sender
     * @param toAddress receiver
     * @param ccAddresses list of cc
     * @param notification notification
     * @param <T> Class that extends Notification interface
     * @return true if mail is sent
     */
    boolean send(String from, String toAddress, List<String> ccAddresses, Notification notification)
        throws NotificationException;

    /**
     * Send notification
     * @param from sender
     * @param toAddress receiver
     * @param ccAddresses list of cc
     * @param ccnAddresses list of ccn
     * @param notification notification
     * @param <T> Class that extends Notification interface
     * @return true if mail is sent
     */
    boolean send(String from, String toAddress, List<String> ccAddresses, List<String> ccnAddresses,
        Notification notification) throws NotificationException;

    /**
     * Send notification
     * @param from sender
     * @param toAddress receiver
     * @param notification notification
     * @param <T> Class that extends Notification interface
     * @return true if mail is sent
     */
    boolean send(String from, String toAddress, Notification notification) throws NotificationException;

    /**
     * Send notification
     * @param from sender
     * @param toAddresses list of receivers
     * @param notification notification
     * @param <T> Class that extends Notification interface
     * @return true if mail is sent
     */
    boolean send(String from, List<String> toAddresses, Notification notification) throws NotificationException;

}